=== debian/changelog ===
wasix-libc (2024.07.08.1+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1056052)

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Sun, 25 Aug 2024 06:48:36 +0000
