=== debian/rules ===
#!/usr/bin/make -f

export NM = llvm-nm-16
export AR = llvm-ar-16
export CC = clang-16
export TARGET_OS = wasix
export TARGET_ARCH = wasm32

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- finish

override_dh_installexamples:
	dh_installexamples -Xgitignore


override_dh_auto_install:
	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr
	find $(CURDIR)/debian/tmp/usr -type d -empty -delete
