## wasix-libc 2025.07.07.1+ds

=== Makefile ===
--- 
+++ 
@@ -21,6 +21,8 @@
 BUILD_LIBC_TOP_HALF ?= yes
 # The directory where we will store intermediate artifacts.
 OBJDIR ?= build/$(TARGET_TRIPLE)
+# Whether to compile with PIC (needed for shared libs and dynamic linking)
+PIC ?= no
 
 # When the length is no larger than this threshold, we consider the
 # overhead of bulk memory opcodes to outweigh the performance benefit,
@@ -92,6 +94,7 @@
         misc/getopt.c \
         misc/getopt_long.c \
         misc/getsubopt.c \
+        misc/initgroups.c \
         misc/getrlimit.c \
         misc/setrlimit.c \
         misc/getrusage.c \
@@ -196,6 +199,11 @@
         linux/epoll.c \
         linux/eventfd.c \
         linux/setgroups.c \
+        ldso/dlclose.c \
+        ldso/dlerror.c \
+        ldso/dlinfo.c \
+        ldso/dlopen.c \
+        ldso/dlsym.c \
         stat/futimesat.c \
         legacy/getpagesize.c \
         thread/thrd_sleep.c \
@@ -306,8 +314,3 @@
         thread/pthread_rwlock_trywrlock.c \
         thread/pthread_rwlock_unlock.c \
         thread/pthread_rwlock_wrlock.c \
-        thread/pthread_rwlockattr_destroy.c \
-        thread/pthread_rwlockattr_init.c \
-        thread/pthread_rwlockattr_setpshared.c \
-        thread/pthread_setcancelstate.c \
-        thread/pthread_setspecific.c \
