=== test/wasix/c_pthreads/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.0)
project (basic_executable)

add_executable(main main.c)
