=== debian/changelog ===
wasix-libc (2025.07.07.1+ds-1) unstable; urgency=medium

  [ Fukui Daichi ]
  * d/rules: Remove obsoleted get-orig-source target
  * New upstream version 2025.07.07.1
  * d/patches: Fix imcompatible cast
  * d/patches: Remove undefined symbols
  * d/control: Update to remove versioned clang/llvm (Closes: #1103497)
  * d/rules: Remove versioned clang/llvm commands

  [ Dmitry Smirnov ]
  * watch: rewrite for Github API.

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Thu, 28 Aug 2025 23:17:25 +0900
