## wasix-libc 2025.12.24.1+ds

=== Makefile ===
--- 
+++ 
@@ -23,6 +23,11 @@
 OBJDIR ?= build/$(TARGET_TRIPLE)
 # Whether to compile with PIC (needed for shared libs and dynamic linking)
 PIC ?= no
+# Whether to verify the build symbols against the expected symbol list.
+# Disabling this is useful for development, where differences in the
+# exact version of clang can cause some symbols (especially macros) to
+# be added or removed.
+CHECK_SYMBOLS ?= yes
 
 # When the length is no larger than this threshold, we consider the
 # overhead of bulk memory opcodes to outweigh the performance benefit,
@@ -66,8 +71,9 @@
 LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c,$(LIBC_BOTTOM_HALF_ALL_SOURCES))
 LIBC_BOTTOM_HALF_ALL_SOURCES := $(LIBC_BOTTOM_HALF_ALL_SOURCES) $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c
 
+# shm_open.c is included in the main libc.
 LIBWASI_EMULATED_MMAN_SOURCES = \
-    $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c))
+    $(filter-out %/shm_open.c,$(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c)))
 LIBWASI_EMULATED_PROCESS_CLOCKS_SOURCES = \
     $(sort $(shell find $(LIBC_BOTTOM_HALF_DIR)/clocks -name \*.c))
 LIBWASI_EMULATED_GETPID_SOURCES = \
@@ -102,6 +108,7 @@
         misc/nftw.c \
 	misc/realpath.c \
         misc/syslog.c \
+        mman/shm_open.c \
         errno/strerror.c \
         \
         network/services.c \
@@ -152,6 +159,7 @@
         time/asctime_r.c \
         time/ctime.c \
         time/ctime_r.c \
+        time/clock.c \
         time/wcsftime.c \
         time/strptime.c \
         time/difftime.c \
@@ -194,6 +202,10 @@
         unistd/ualarm.c \
         unistd/ttyname.c \
         unistd/ttyname_r.c \
+        unistd/chown.c \
+        unistd/fchown.c \
+        unistd/fchownat.c \
+        unistd/lchown.c \
         linux/wait3.c \
         linux/wait4.c \
         linux/epoll.c \
@@ -206,7 +218,14 @@
         ldso/dlsym.c \
         stat/futimesat.c \
         legacy/getpagesize.c \
+        legacy/getpass.c \
         thread/thrd_sleep.c \
+        wasix/call_dynamic.c \
+        wasix/closure_allocate.c \
+        wasix/closure_free.c \
+        wasix/closure_prepare.c \
+        wasix/reflection.c \
+        wasix/context.c \
     ) \
     $(filter-out %/procfdname.c %/syscall.c %/syscall_ret.c %/vdso.c %/version.c, \
                  $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/*.c)) \
@@ -298,19 +317,3 @@
         thread/pthread_mutex_timedlock.c \
         thread/pthread_mutex_trylock.c \
         thread/pthread_mutex_unlock.c \
-        thread/pthread_mutexattr_destroy.c \
-        thread/pthread_mutexattr_init.c \
-        thread/pthread_mutexattr_setprotocol.c \
-        thread/pthread_mutexattr_setpshared.c \
-        thread/pthread_mutexattr_setrobust.c \
-        thread/pthread_mutexattr_settype.c \
-        thread/pthread_once.c \
-        thread/pthread_rwlock_destroy.c \
-        thread/pthread_rwlock_init.c \
-        thread/pthread_rwlock_rdlock.c \
-        thread/pthread_rwlock_timedrdlock.c \
-        thread/pthread_rwlock_timedwrlock.c \
-        thread/pthread_rwlock_tryrdlock.c \
-        thread/pthread_rwlock_trywrlock.c \
-        thread/pthread_rwlock_unlock.c \
-        thread/pthread_rwlock_wrlock.c \
