=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Fukui Daichi <a.dog.will.talk@akane.waseda.jp>
 Build-Depends: debhelper-compat (= 13), clang, llvm, libclang-rt-dev-wasm32
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://github.com/wasix-org/wasix-libc
 Rules-Requires-Root: no
